con
  _CLKMODE      = XTAL1 + PLL16X                        
  _XINFREQ      = 5_000_000

var
  long buffer[1024]
  
obj
  desc: "COGdesc"
  'term: "FullDuplexSerial"
  term: "CogOS_IO(Term)"

pub main | tmp,i,j
  term.start(0,0)
  
  ' wait until any key has been pushed
  tmp:=-1
  repeat while tmp==-1
    term.str( string( "DescTest",$0d,"== please press key to start ==",$0d ) )
    tmp:=term.rxtime( 1000 )
  
  desc.initRAMDesc( 15 )
  ' this initializes the parameter-manager which can be asked for upper memory
  desc.initPARmng
  
  ' start the code that knows how to read the driver table
  ' and give it some space ( 512 bytes for directory + 512 longs for driver)
  ' after loading all needed drivers the buffers can be used 
  desc.initDesc( @buffer )

  j:=desc.getDrvCnt
  term.dec( j )  
  nl
  repeat i from 0 to j-1
    desc.getDescrFrom( i )
    desc.getName( @buffer+512 )
    term.dec( i+1 )
    term.str( string(".") ) 'term.tx( "." )
    term.str( @buffer+512 )
    spc
    term.str( string(" V" ) )
    term.hex( desc.getVersion,4 )
    term.str( string( " @" ) )
    term.hex( i<<11 + $8000, 4 )
    term.str( string( " #" ) )
    term.dec( desc.getPSize )
    term.str( string( " " ) )
    'term.hex( desc.Hash( @key_buffer, desc.getVersion ), 8 )
    nl

  peek( $7f00-128, 256+128 )
  term.rx

  tmp := desc.loadDriver( @fdserial , $0110 )
  tmp := desc.parReserve( desc.getPSize )
  repeat desc.getPSize
    long[ tmp ]:=$11111111
    tmp+=4

  peek( $7f00-128, 256+128 )
  term.rx
  
  tmp := desc.loadDriver( @sdcard , $0170 )
  tmp := desc.parReserve( desc.getPSize )
  repeat desc.getPSize
    long[ tmp ]:=$22222222
    tmp+=4

  peek( $7f00-128, 256+128 )
  term.rx
  
  tmp := desc.loadDriver( @lcddrv , $0099 )
  tmp := desc.parReserve( desc.getPSize )
  repeat desc.getPSize
    long[ tmp ]:=$33333333
    tmp+=4

  peek( $7f00-128, 256+128 )
  
  repeat

pub peek( adr, len ) | tmp,tmp1,i,j,k

          j:=adr'  & $ffff_fff0
          len := (len#>1)
          tmp := j+len        
          i:=true
          repeat len
            if (j//16)==0 or i
              nl
              term.hex( j, 4 )
              spc
              if i
                repeat 3*( adr&$f )
                  spc            
                i := false
            term.hex( byte[ j ],2 )
            spc
            j+=1

            if (j//16)==0 or j==tmp
              if j==tmp
                repeat 3*( 15-(j-1)&15)
                  spc            
              term.tx( "|" )
              repeat k from j-16 to j-1
                tmp1 := byte[ k ]
                if tmp1>16
                  term.tx( tmp1 )
                else
                  term.tx( "." )
              term.tx( "|" )
          nl
  
pub nl
  term.tx($0d)

pub spc
  term.tx(" ")   

dat
sdcard        byte      "SDcard",0
fdserial      byte      "FDSerial",0
lcddrv        byte      "BenkyLCD",0
  