con
  NOT_FOUND     = -1
  WRONG_VERSION = -2
  IS_RUNNING    = -3

  FLAG_RUNNING   = $01
  FLAG_SUSPENDED = $02
  FLAG_LINKED    = $04

  RAM_ENTRY_SIZE    = 12
  
  COG_DESC_TAB  = $8000 - 8

pub initRAMDesc : ramDesc
  ' in case an application stopped, the descriptor table is already there
  if long[COG_DESC_TAB] & $ffff_ff00 <> ram_id
    ramDesc := true
  else
    ramDesc := false

pub getMaxRAM | padr
  ' descriptor table initialized as well?
  if ( long[COG_DESC_TAB] & $ffff_ff00 ) == RAM_id
    padr := long[ constant( COG_DESC_TAB+4 ) ] - 4
  else
    padr := constant( COG_DESC_TAB - 8 )

  ' in case an application stopped, the parameter table is already there
  if long[ padr ] & $ffff_ff00 == PAR_id
    return long[ padr + 4 ] - 1
  else
    return padr+7 
        
pub findRAMDrv(startFrom, hashVal ) : i
  repeat i from startFrom to getRAMDrvCnt
    if getRAMHash( i ) == hashVal
      if (getRAMStatus( i ) & FLAG_LINKED) == 0
        return
  return -1

pub setLink( num, val )
  if val
    long[ constant(COG_DESC_TAB + 4) - RAM_ENTRY_SIZE*num ] |= FLAG_LINKED
  else
    long[ constant(COG_DESC_TAB + 4) - RAM_ENTRY_SIZE*num ] &= !FLAG_LINKED
  
pub getRAMDrvCnt
  return byte[ COG_DESC_TAB ]

pub getRAMStatus( i )
  return long[ constant(COG_DESC_TAB + 4) - RAM_ENTRY_SIZE*i ] & $FF
 
pub getRAMParAddress( i )
  return long[ constant(COG_DESC_TAB + 4) - RAM_ENTRY_SIZE*i ] >> 16 & $ffff

pub getRAMParSize( i )
  return long[ constant(COG_DESC_TAB + 8) - RAM_ENTRY_SIZE*i ] & $ffff

pub getRAMHash( i )
  return long[ COG_DESC_TAB - RAM_ENTRY_SIZE*i ]

pub getRAMCOG( i )
  return long[ constant(COG_DESC_TAB + 4) - RAM_ENTRY_SIZE*i ]>>8 & $ff

pub Hash(string_ptr, version) : Result | x
 result := 0
 repeat strsize(string_ptr)
   Result := (Result << 4) + byte[string_ptr++]
   x := Result & $F0_00_00_00
   if (x <> 0)
    Result := Result ^ (x >> 24)
   Result := (result & !x ) ^ version

dat

RAM_id  long  $43_4F_47_00
PAR_id  long  $50_41_52_00
 